        ************** Invmenu COMMAND FILE  ****************** 
* This menu leads into command files that work with two data
* files, Billings and Invoices.  Billings keeps track of the amount
* billed to a client by individual job number, while Invoices is a
* summary of the total billed on any given invoice.  This latter file can
* be used to set up an accounts receivable system, as it has fields for
* storing how much has been received in payment against an invoice and
* when that amount was received (filled in by the Deposits.prg file).
*************************************************************************
SELECT 1
USE Invget
SELECT 7
USE Claddres 
SELECT 8
USE Invoices INDEX Invoices
SELECT 9
USE Billings INDEX Billings, Billjobs
*
DO WHILE .T.
   CLEAR
   @  2, 0 SAY '* * * * * * *   C L I E N T   B I L L I N G   * * * * * * *'
   @  4,20 SAY '1> Bill Clients by Job'
   @  6,20 SAY '2> Edit/Print Invoices in Entry File'
   @  8,20 SAY '3> Print Invoice Forms'
   @ 10, 0 SAY '* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *'
   @ 12,20 SAY 'Choose a number or press <ENTER>'
   @ 13, 0
   *
   WAIT ' ' TO Invoicing
   *
   DO CASE
      CASE Invoicing = '1'
         @ ROW(),0 SAY 'Preparing to Bill Clients by Job'
         DO Invoices
      CASE Invoicing = '2'
         @ ROW(),0 SAY 'Preparing Invoices in Entry File'
         DO Invedit
      CASE Invoicing = '3'
         @ ROW(),0 SAY 'Preparing to Print Invoice Forms'
         SELECT 1
         GO TOP
         CLEAR
         IF EOF()
            WAIT ;
            'There are no INVOICES to be printed.  Type any key to continue'
         ELSE
            * Invoices are all checked to see that only jobs for one client
            * are entered against an invoice.  Necessary because they could
            * have been changed by editing.
            PUBLIC Aborted
            Aborted = .F.
            DO Invcheck
            IF .NOT. Aborted
               DO Invprint
               DO Invupdat
            ENDIF
         ENDIF
      CASE LEN(Invoicing) = 0
         @ ROW(),0 SAY 'Returning to Main Menu'
         CLOSE DATABASE
         RETURN
         *
      OTHERWISE
      *
   ENDCASE Invoicing
ENDDO
